from typing import Optional

from bot_data.abc.history_table_abc import HistoryTableABC
from bot_data.model.server import Server


class LevelHistory(HistoryTableABC):
    def __init__(
        self,
        name: str,
        color: str,
        min_xp: int,
        permissions: int,
        server: Optional[Server],
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._name = name
        self._color = color
        self._min_xp = min_xp
        self._permissions = permissions
        self._server = server

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._id

    @property
    def name(self) -> str:
        return self._name

    @property
    def color(self) -> str:
        return self._color

    @property
    def min_xp(self) -> int:
        return self._min_xp

    @property
    def permissions(self) -> int:
        return self._permissions

    @property
    def server(self) -> Server:
        return self._server
