from cpl_discord.service import DiscordBotServiceABC

from bot_data.abc.auto_role_repository_abc import AutoRoleRepositoryABC
from bot_data.abc.server_repository_abc import ServerRepositoryABC
from bot_data.model.auto_role import AutoRole
from bot_graphql.abc.history_query_abc import HistoryQueryABC


class AutoRoleHistoryQuery(HistoryQueryABC):
    def __init__(
        self,
        bot: DiscordBotServiceABC,
        auto_role_rules: AutoRoleRepositoryABC,
        servers: ServerRepositoryABC,
    ):
        HistoryQueryABC.__init__(self, "AutoRole")

        self._bot = bot
        self._auto_role_rules = auto_role_rules
        self._servers = servers

        self.set_field("id", self.resolve_id)
        self.set_field("channelId", self.resolve_channel_id)
        self.set_field("messageId", self.resolve_message_id)
        self.set_field("server", self.resolve_server)

    @staticmethod
    def resolve_id(x: AutoRole, *_):
        return x.id

    @staticmethod
    def resolve_channel_id(x: AutoRole, *_):
        return x.discord_channel_id

    @staticmethod
    def resolve_message_id(x: AutoRole, *_):
        return x.discord_message_id

    def resolve_server(self, x: AutoRole, *_):
        return x.server
