from cpl_discord.service import DiscordBotServiceABC

from bot_data.model.user_joined_game_server import UserJoinedGameServer
from bot_graphql.abc.history_query_abc import HistoryQueryABC


class UserJoinedGameServerHistoryQuery(HistoryQueryABC):
    def __init__(self, bot: DiscordBotServiceABC):
        HistoryQueryABC.__init__(self, "UserJoinedGameServer")

        self._bot = bot

        self.set_field("id", self.resolve_id)
        self.set_field("gameServer", self.resolve_game_server)
        self.set_field("user", self.resolve_user)
        self.set_field("joinedOn", self.resolve_joined_on)
        self.set_field("leavedOn", self.resolve_leaved_on)

    @staticmethod
    def resolve_id(x: UserJoinedGameServer, *_):
        return x.id

    @staticmethod
    def resolve_game_server(x: UserJoinedGameServer, *_):
        return x.game_server.name

    @staticmethod
    def resolve_user(x: UserJoinedGameServer, *_):
        return x.user

    @staticmethod
    def resolve_time(x: UserJoinedGameServer, *_):
        return x.time

    @staticmethod
    def resolve_joined_on(x: UserJoinedGameServer, *_):
        return x.joined_on

    @staticmethod
    def resolve_leaved_on(x: UserJoinedGameServer, *_):
        return x.leaved_on
