from typing import Callable


class AchievementAttribute:
    # frontend type = TypeScript types
    def __init__(self, name: str, resolver: Callable, frontend_type: str):
        self._name = name
        self._resolver = resolver
        self._frontend_type = frontend_type

    @property
    def name(self) -> str:
        return self._name

    @property
    def type(self) -> str:
        return self._frontend_type

    def resolve(self, *args, **kwargs):
        return self._resolver(*args, **kwargs)
