from cpl_core.configuration import ConfigurationABC
from cpl_core.logging import LoggerABC
from cpl_discord.container import Guild
from cpl_discord.events import OnReadyABC
from cpl_discord.service import DiscordBotServiceABC

from bot_data.abc.server_config_repository_abc import ServerConfigRepositoryABC
from bot_data.abc.server_repository_abc import ServerRepositoryABC


class ConfigOnReadyEvent(OnReadyABC):
    def __init__(
        self,
        config: ConfigurationABC,
        logger: LoggerABC,
        bot: DiscordBotServiceABC,
        servers: ServerRepositoryABC,
        server_config_repo: ServerConfigRepositoryABC,
    ):
        OnReadyABC.__init__(self)

        self._config = config
        self._logger = logger
        self._bot = bot
        self._servers = servers
        self._server_config_repo = server_config_repo

    async def on_ready(self):
        for guild in self._bot.guilds:
            guild: Guild = guild
            server = self._servers.get_server_by_discord_id(guild.id)
            server_config = self._server_config_repo.get_server_config_by_server(server.id)
            self._config.add_configuration(
                f"{type(server_config).__name__}_{server_config.server.discord_id}", server_config
            )
