import { GameServer, Server } from "../data/server.model";
import { User } from "../data/user.model";
import { AutoRole, AutoRoleRule } from "../data/auto_role.model";
import { Guild } from "../data/discord.model";
import { Level } from "../data/level.model";
import { Achievement, AchievementAttribute } from "../data/achievement.model";
import { TechnicianConfig } from "../config/technician-config.model";
import { ServerConfig } from "../config/server-config.model";

export interface Query {
  serverCount: number;
  servers: Server[];
}

export interface TechnicianConfigQuery {
  technicianConfig: TechnicianConfig;
}

export interface ServerConfigQuery {
  config: ServerConfig;
}

export interface SingleDiscordQuery {
  guilds: Guild[];
}

export interface UserListQuery {
  userCount: number;
  users: User[];
}

export interface GameServerListQuery {
  gameServerCount: number;
  gameServers: GameServer[];
}

export interface LevelListQuery {
  levelCount: number;
  levels: Level[];
}

export interface AchievementTypeQuery {
  achievementAttributes: AchievementAttribute[];
  achievementOperators: string[];
}

export interface AchievementListQuery {
  achievementCount: number;
  achievements: Achievement[];
}

export interface AutoRoleQuery {
  autoRoleCount: number;
  autoRoles: AutoRole[];
}

export interface AutoRoleRuleQuery {
  autoRoleRuleCount: number;
  autoRoleRules: AutoRoleRule[];
}

